<?php
// Exit if accessed directly
if (!defined('ABSPATH')) exit;
add_action('admin_menu', 'dbx_dpd_admin_menu');
function dbx_dpd_admin_menu(){
    add_options_page( esc_html__('Setări DPD', 'woo-dbx-dpd' ), esc_html__('Setări DPD', 'woo-dbx-dpd' ), 'manage_options', 'dbx-dpd-settings-page','dbx_dpd_options_page' );
}
add_action('admin_init', function() {
    register_setting( 'dbx-dpd-settings-group', 'dbx-dpd-plugin-settings' );
  	add_settings_section( 'dbx-dpd-settings-section', esc_html__( 'Setări DPD', 'woo-dbx-dpd' ), 'dbx_dpd_settings_callback', 'dbx-dpd-settings-page' );
  	add_settings_section( 'adv-section', esc_html__( 'Dabex Agency', 'woo-dbx-dpd' ), 'dbx_dpd_adv_callback', 'dbx-dpd-adv-page' );
  	add_settings_field( 'dbx_dpd_auth_key', '', 'dbx_dpd_auth_key_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_validate', '', 'dbx_dpd_validate_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_activation_id', '', 'dbx_dpd_activation_id_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_username', '', 'dbx_dpd_username_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_pass', '', 'dbx_dpd_pass_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_id', '', 'dbx_dpd_id_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_service_id', '', 'dbx_dpd_service_id_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_platitor', '', 'dbx_dpd_platitor_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_ls', '', 'dbx_dpd_ls_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_dc', ' ', 'dbx_dpd_dc_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_format_awb', ' ', 'dbx_dpd_format_awb_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_nr_colete', ' ', 'dbx_dpd_nr_colete_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_livrare','', 'dbx_dpd_livrare_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' ); 
  	add_settings_field( 'dbx_dpd_autogenerate','','dbx_dpd_autogenerate_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' );
  	add_settings_field( 'dbx_dpd_update_comanda','', 'dbx_dpd_update_comanda_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' ); 
    add_settings_field( 'dbx_dpd_update_mail','','dbx_dpd_update_mail_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' ); 
    add_settings_field( 'dbx_dpd_text_mail','', 'dbx_dpd_text_mail_callback', 'dbx-dpd-settings-page', 'dbx-dpd-settings-section' ); 
  	include_once (DBX_DPD_PLUGIN_PATH.'/admin/settings-template.php');
});
function dbx_dpd_options_page(){
    ?>
    <div class="wrap-settings">
      <div class="dbx-dpd-settings-section">
      <form action="options.php" method="POST">
        <?php settings_fields('dbx-dpd-settings-group'); ?>
        <?php do_settings_sections('dbx-dpd-settings-page'); ?>
        <?php submit_button(); ?>
      </form>
      </div>
      <div class="adv-section">
      <?php do_settings_sections('dbx-dpd-adv-page'); ?>          
      </div>    
    </div>
    <?php
}
add_action( 'admin_print_styles-settings_page_dbx-dpd-settings-page', 'dbx_dpd_enqueque_style');
function dbx_dpd_enqueque_style(){
        wp_register_style("dbx_dpd_style", plugins_url('assets/dbx_dpd.css', __FILE__), false, "1.0.0");
        wp_enqueue_style( 'dbx_dpd_style' );
        wp_register_style( 'dbx_dpd_select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.8/css/select2.min.css', false, '4.0.8');
        wp_enqueue_style( 'dbx_dpd_select2' );
        wp_enqueue_script('dbx_select2', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.8/js/select2.min.js', array('jquery'), '4.0.8', true);
        wp_register_script('dbx_dpd_auth', plugins_url('assets/js/dbx_dpd_auth.js', __FILE__), array('jquery'), '1.0.2', false);
        wp_enqueue_script('dbx_dpd_auth');
}