<?php
add_action('wp', function () {
    if (!wp_next_scheduled('dbx_status_update')) {
        wp_schedule_event(time(), 'twicedaily', 'dbx_status_update');
    }
});
add_action('dbx_status_update', 'update_status_dbx');
function update_status_dbx(){
    global $wpdb;
    $key      = 'dbx_awb_dpd_status_id';
    $value    = '9999';
    $orders = $wpdb->get_results($wpdb->prepare("SELECT * FROM " . $wpdb->postmeta . " WHERE meta_key=%s AND meta_value!=%s", $key, $value));
    if(count($orders)){
        foreach($orders as $ord){
            $awb_id = get_post_meta($ord->post_id,'dbx_awb_dpd', true);
            $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
            $username = isset($settings['dbx_dpd_username']) ? esc_attr($settings['dbx_dpd_username']) : '';
            $pass     = isset($settings['dbx_dpd_pass']) ? esc_attr($settings['dbx_dpd_pass']) : '';
            $awbs []= $awb_id;
            if(empty($awb_id)) continue;
            $awb_data = [
                'username_dpd'  => $username,
                'password_dpd'  => $pass, 
                'last_only'     => 'true',
                'awb_id'        => $awb_id
                ];
            $data = json_encode($awb_data);
            $response = (new WOO_DPD_API)->call_API($data,'tracking');
            $rasp = json_decode($response);
            foreach($rasp->parcels as $track){
                $op = $track->operations;
                $new_status = $op[0]->description;
            }
            update_post_meta($ord->post_id, 'dbx_awb_dpd_status', $new_status);
        }
    }
}