<?php
add_action('admin_menu', 'add_generate_page_dpd');
function add_generate_page_dpd(){
    add_submenu_page(
        'Genereaza AWB DPD', 
        'Genereaza AWB DPD', 
         null,
        'manage_woocommerce', 
        'generate-awb-dpd', 
        'generate_page_dpd', 
        null
    );
}
function generate_page_dpd(){
    $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
    $validate = isset($settings['dbx_dpd_validate']) ? esc_attr($settings['dbx_dpd_validate']) : '';
    if($validate != 'succes'){
        die('Licenta invalida!');
    }
    $username = isset($settings['dbx_dpd_username']) ? esc_attr($settings['dbx_dpd_username']) : '';
    $pass = isset($settings['dbx_dpd_pass']) ? esc_attr($settings['dbx_dpd_pass']) : '';
    $dpd_point = isset($settings['dbx_dpd_id']) ? esc_attr($settings['dbx_dpd_id']) : '';
    $service_id = isset($settings['dbx_dpd_service_id']) ? esc_attr($settings['dbx_dpd_service_id']) : '';
    $livrare_sambata = isset($settings['dbx_dpd_ls']) ? esc_attr($settings['dbx_dpd_ls']) : '';
    $deschidere_colet = isset($settings['dbx_dpd_dc']) ? esc_attr($settings['dbx_dpd_dc']) : '';
    $nr_colete = isset($settings['dbx_dpd_nr_colete']) ? esc_attr($settings['dbx_dpd_nr_colete']) : '';
    if ($validate != 'succes'){
        echo '<div class="wrap"><h1>Woocommerce DBX - dpd</h1><br><h2>Licența dvs. pentru modulul Woocommerce DBX - dpd a expirat.</h2> Va rugam dati click <a href="/wp-admin/options-general.php?page=dbx-dpd-settings-page'.'"> aici</a> pentru a verifica licența dvs.</div>';
        exit;
    }
    $order = wc_get_order($_GET['order_id']);
    if(!$order){
        die('Invalid order id');   
    }
    $observatii = '';
    if ($order->get_customer_note() != '') {
    $observatii = $order->get_customer_note();
    }
    $weight = 0;
    $contents = [];
    $height = 0;
    $width = 0;
    $length = 0;
    $totalheight = [];
    $totallength = [];
    $items = $order->get_items();
    foreach($items as $k=>$item){
        $product = $item->get_product();   
        $name = $product->get_name();
        $sku = $product->get_sku();
        if(empty($sku)){
            $sku = $product->get_product_id();
        }
        $total = $item->get_total();
        $total = str_replace(",",".", $total);
        $contents []= $item->get_quantity().' x '.$name;
        if ( !$product->is_virtual()) {
            if(!empty($product->get_weight())){
                $weight += $product->get_weight() * $item->get_quantity();    
            }
            else{
                $weight = 1;
            }
            $height       = (int) $product->get_height();
            $totalheight[] = $height;
            $length       = (int) $product->get_length();
            $totallength[] = $length;
        }
    }
    $height = max($totalheight);
    $length = max($totallength);
    if($height == 0){ $height = 10; }
    if($length == 0){ $length = 10; }
    if($width == 0) { $width  = 10; }
    $weight_type = get_option('woocommerce_weight_unit');
    if ($weight_type == 'g') { $weight = $weight / 1000; }
    $contents = implode(', ', $contents);
    $platitor = isset($settings['dbx_dpd_platitor']) ? esc_attr($settings['dbx_dpd_platitor']) : '';
    if($platitor == 'SENDER'){ $ramburs = $order->get_total(); }
    if($platitor == 'RECIPIENT'){ $ramburs = number_format((float) $order->get_total() - $order->get_shipping_total() - $order->get_shipping_tax(), wc_get_price_decimals(), '.', ''); }
    if($order->get_payment_method() == 'cod'){
        $ramburs = $ramburs;
    }
    else {
        $ramburs = 0;
    }
    $contactPerson = $order->get_shipping_first_name().' '.$order->get_shipping_last_name();
    if($order->get_shipping_company()){
        $nume = $order->get_shipping_company();
        $private = 'true';
    }
    else{
        $nume = $contactPerson;
        $private = 'false';
    }
    $adresa = $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2();
    $county  = remove_accents(dbx_get_counties($order->get_shipping_state()));
    $city    = remove_accents($order->get_shipping_city());
    $country = $order->get_shipping_country();
    $country_id     = '';
    $currency       = '';
    if($country == 'RO')  {$country_id = '642'; $currency = 'RON';}
    if($country == 'GR')  {$country_id = '300'; $currency = 'EUR';}
    if($country == 'HU')  {$country_id = '348'; $currency = 'HUF';}  
    if($country == 'BG')  {$country_id = '100'; $currency = 'BGN';}  
    if($country == 'PL')  {$country_id = '616'; $currency = 'PLN';}
    $endpoint = 'generate';
    if($country == 'RO'){ $endpoint = 'generate_ro';}
    include_once(plugin_dir_path(__FILE__) . '/dpd-awb.php');
}
add_action('admin_notices', 'dbx_dpd_admin_notices', 99);
function dbx_dpd_admin_notices(){
    if(get_option('dpd_dbx_error')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'dpd_dbx_error' ), 'woo-dbx-dpd' ); ?></p>
        </div>
        <?php
        delete_option('dpd_dbx_error');
    }
    if(get_option('dpd_delete_success')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'dpd_delete_success' ), 'woo-dbx-dpd' ); ?></p>
        </div>
        <?php
        delete_option('dpd_delete_success');
    }
    if(get_option('dpd_succes_delete_error')){
        ?>
        <div class="notice notice-success is-dismissible">
        <p><?php _e( get_option( 'dpd_succes_delete_error' ), 'woo-dbx-dpd' ); ?></p>
        </div>
        <?php
        delete_option('dpd_succes_delete_error');
    }
}
add_action('add_meta_boxes', 'dbx_metabox_dpd');
function dbx_metabox_dpd(){
    add_meta_box(
		'dbx_metabox_dpd', 
		esc_html__('AWB DPD', 'woo-dbx-dpd'),
		'dbx_metabox_dpd_html',
		'shop_order',
		'side', 
		'core'
	);    
}
function dbx_metabox_dpd_html($post){
    $awb_no = get_post_meta($post->ID, 'dbx_awb_dpd', true ); 
    $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
    $status_id = get_post_meta($post->ID, 'dbx_awb_dpd_status_id', true );
    $status = get_post_meta($post->ID, 'dbx_awb_dpd_status', true );
    $delete_url = plugin_dir_url(__DIR__).'includes/delete.php?&order_id='.$post->ID;
    $download_url = plugin_dir_url( __DIR__ ).'includes/download.php?&order_id='.$post->ID;
    if($awb_no){
        ?>
		<div class="order_data_column_container">
			<div style="display:flex;">
			<p> Nr. AWB: <b><?php echo $awb_no;?></b></p>
			</div>
			<div style="display:flex;gap:10px;width:100%;flex-flow: row wrap;">
			<a style="flex: 1 auto;text-align: center;" class="button-primary" href="<?php echo $download_url;?>" target="_blank" ><?php echo esc_html__('Tiparește','woo-dbx-dpd');?></a>    
            <a style="flex: 1 auto;text-align: center;" class="button-primary" href="https://tracking.dpd.ro/?shipmentNumber=<?php echo $awb_no;?>" target="_blank" ><?php echo esc_html__('Urmărește AWB','woo-dbx-dpd');?></a>				
            <a style="flex: 1 auto;text-align: center;" class="button-primary" href="<?php echo $delete_url;?>"><?php echo esc_html__('Șterge AWB','woo-dbx-dpd');?></a>
			</div>
			<div class="dpd_notice" style="background: #C8D7E1;border-radius: 4px;padding: 5px;margin-top:5px;box-shadow: 0 2px 4px #ccc;">
			<div class="dpd-notice" style="font-size: 12px;line-height: 1.85;padding-left: 5px;"><span class="dashicons dashicons-info"></span><span>Status: <?php echo $status ;?></span></div>
			</div>
		</div>
        <?php
    }
    else {
        ?>
		<div class="order_data_column_container">
			<div style="display:flex;gap:10px;width:100%;flex-flow: row wrap;">
			<a style="flex: 1 auto;text-align: center;" class="button-primary" href="admin.php?page=generate-awb-dpd&order_id=<?php echo $post->ID ;?>"><?php echo esc_html__('Generează AWB','woo-dbx-dpd');?></a>    
			</div>
		</div>
        <?php
    }
}
add_filter('manage_edit-shop_order_columns', 'dpd_order_table_column', 10);
function dpd_order_table_column($cols){
    $new_cols = $cols;
    if (!is_array($cols)) {
        $cols = array();
    }
    $new_cols['awb_dpd_col'] = 'AWB DPD Curier';
    return $new_cols;
}
add_action('manage_shop_order_posts_custom_column', 'dpd_order_table_column_data', 6); 
function dpd_order_table_column_data($column){
    global $post;
    if($column == 'awb_dpd_col'){
    $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
    $awb_no = get_post_meta($post->ID, 'dbx_awb_dpd', true ); 
    $status_id = get_post_meta($post->ID, 'dbx_awb_dpd_status_id', true );
    $status = get_post_meta($post->ID, 'dbx_awb_dpd_status', true );
    $delete_url = plugin_dir_url(__DIR__).'includes/delete.php?&order_id='.$post->ID.'&bulk=1';
    $download_url = plugin_dir_url( __DIR__ ).'includes/download.php?&order_id='.$post->ID;
    if($awb_no){
        ?>
        <a id="printDPD" class="button-print tips" data-tip="<?php echo esc_html__('Printează AWB','woo-dbx-dpd');?>" href="<?php echo $download_url.'&bulk=1' ;?>" style="cursor: pointer;border-radius:4px;display: inline-block;width:60%;text-align:center;height:30px;background-color:#C6E1C6;box-shadow: 0 2px 4px #ccc;color: #5b841b;line-height: 2.3em;font-weight: 600;font-size: 14px;" target="_blank"><span class="dashicons dashicons-pdf" style="font-size: 20px;line-height: 1.6em;margin-left: 5px;display: inherit;vertical-align: middle;height: 20px;width: 20px;float: left;"></span><?php echo $awb_no;?></a>
        <a class="button-remove tips" data-tip="<?php echo esc_html__('Șterge AWB','woo-dbx-dpd');?>" href="<?php echo $delete_url;?>" style="cursor: pointer;border-radius: 4px;display: inline-block;width: 18%;text-align: center;height: 30px;background-color: #F0F0F1;box-shadow: 0 2px 4px #ccc;color: #EA2024;line-height: 2.4em;"><span class="dashicons dashicons-no" style="font-size: 25px;display: inherit;vertical-align: middle;height: 25px;width: 25px;"></span></a>
        <a class="button-remove tips" data-tip="<?php echo esc_html__('Urmărește AWB','woo-dbx-dpd');?>" href="https://tracking.dpd.ro/?shipmentNumber=<?php echo $awb_no;?>" style="cursor: pointer;border-radius: 4px;display: inline-block;width: 18%;text-align: center;height: 30px;background-color: #F0F0F1;box-shadow: 0 2px 4px #ccc;color: #2271b1;line-height: 2.4em;" target="_blank"><span class="dashicons dashicons-location-alt" style="font-size: 25px;display: inherit;vertical-align: middle;height: 25px;width: 25px;line-height: 0.8em;"></span></a>
        <div class="dpd_notice" style="background: #C8D7E1;border-radius: 4px;padding: 5px;margin-top:5px;box-shadow: 0 2px 4px #ccc;">
            <div class="dpd-notice" style="font-size: 12px;line-height: 1.85;padding-left: 5px;"><span class="dashicons dashicons-info"></span><span>Status: <?php echo $status ;?></span></div>
        </div>
        <a id="downloadDPD" style="display:none;" href="<?php echo $download_url.'&bulk=1' ;?>"><?php echo $awb_no;?></a>
        <?php
    }
    else{
        $generate_url = esc_url(add_query_arg(['dpd_generate_awb'=> $post->ID]));
        ?>
        <a class="button-generate tips" style="cursor: pointer;border:1px solid #2271b1; border-radius:4px;display: block;width:100%;text-align:center;height:35px;background-color:white;box-shadow: 0 2px 4px #ccc;" data-tip="<?php echo esc_html__('Generează AWB','woo-dbx-dpd');?>" href="<?php echo $generate_url;?>"><img src="<?php echo plugin_dir_url(__FILE__).'assets/dpd_logo.png';?>" style="height: 30px;vertical-align: middle;height: 95% !important;object-fit: contain;width: 100%;margin: 0;image-rendering: -webkit-optimize-contrast;"/></a>
        <?php
    }
    }
}
function dpd_generate_awb($bulk_id = NULL){
    global $wpdb;
    $order_id = get_query_var('dpd_generate_awb');
    if($bulk_id){
        $order_id = $bulk_id;
    }
    if($order_id){
      $awb_no = get_post_meta($order_id, 'dbx_awb_dpd', true);
      $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
      $validate = isset($settings['dbx_dpd_validate']) ? esc_attr($settings['dbx_dpd_validate']) : '';
      $update = isset($settings['dbx_dpd_update_comanda']) ? esc_attr($settings['dbx_dpd_update_comanda']) : '';
      $platitor = isset($settings['dbx_dpd_platitor']) ? esc_attr($settings['dbx_dpd_platitor']) : '';
      $username = isset($settings['dbx_dpd_username']) ? esc_attr($settings['dbx_dpd_username']) : '';
      $pass     = isset($settings['dbx_dpd_pass']) ? esc_attr($settings['dbx_dpd_pass']) : '';
      $service_id = isset($settings['dbx_dpd_service_id']) ? esc_attr($settings['dbx_dpd_service_id']) : '';
      $livrare_sambata = isset($settings['dbx_dpd_ls']) ? esc_attr($settings['dbx_dpd_ls']) : '';
      $deschidere_colet = isset($settings['dbx_dpd_dc']) ? esc_attr($settings['dbx_dpd_dc']) : '';
      $nr_colete = isset($settings['dbx_dpd_nr_colete']) ? esc_attr($settings['dbx_dpd_nr_colete']) : '';
      if($awb_no) return;
      if ($validate != 'succes'){
        add_option( 'dbx_dpd_error', 'Licența dvs. pentru modulul Woocommerce DBX - dpd a expirat!');
        return;
      }
      try{
        $order = wc_get_order($order_id);
        $observatii = '';
        if ($order->get_customer_note() != '') {
        $observatii = $order->get_customer_note();
        }
        $weight = 0;
        $contents = [];
        $height = 0;
        $width = 0;
        $length = 0;
        $totalheight = [];
        $totallength = [];
        $items = $order->get_items();
        foreach($items as $k=>$item){
        $product = $item->get_product();   
        $name = $product->get_name();
        $sku = $product->get_sku();
        if(empty($sku)){
            $sku = $product->get_product_id();
        }
        $total = $item->get_total();
        $total = str_replace(",",".", $total);
        $contents []= $item->get_quantity().' x '.$name;
        if ( !$product->is_virtual()) {
            if(!empty($product->get_weight())){
            $weight += $product->get_weight() * $item->get_quantity();    
            }
            else{
            $weight = 1;
            }
            $height       = (int) $product->get_height();
            $totalheight[] = $height;
            $length       = (int) $product->get_length();
            $totallength[] = $length;
        }
        }
        $weight_type = get_option('woocommerce_weight_unit');
        if ($weight_type == 'g') { $weight = $weight / 1000; }
        $contents = implode(', ', $contents);
        if($platitor == 'SENDER'){ $ramburs = $order->get_total(); }
        if($platitor == 'RECIPIENT'){ $ramburs = number_format((float) $order->get_total() - $order->get_shipping_total() - $order->get_shipping_tax(), wc_get_price_decimals(), '.', ''); }
        if($order->get_payment_method() == 'cod'){
        $ramburs = $ramburs;
        }
        else {
        $ramburs = 0;
        }
        $contactPerson = $order->get_shipping_first_name().' '.$order->get_shipping_last_name();
        if($order->get_shipping_company()){
        $nume = $order->get_shipping_company();
        $private = 'true';
        }
        else{
        $nume = $contactPerson;
        $private = 'false';
        }
        if($livrare_sambata == 1){$saturday = 'true';} 
        else{$saturday = 'false';}
        if($deschidere_colet == 1){$open_package = 'OPEN';} 
        $adresa = $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2();
        $county  = remove_accents(dbx_get_counties($order->get_shipping_state()));
        $country = $order->get_shipping_country();
        $city    = remove_accents($order->get_shipping_city());
        $currency       = '';
        if($country == 'RO')  {$country_id = '642'; $currency = 'RON';}
        if($country == 'GR')  {$country_id = '300'; $currency = 'EUR';}
        if($country == 'HU')  {$country_id = '348'; $currency = 'HUF';}  
        if($country == 'BG')  {$country_id = '100'; $currency = 'BGN';}  
        if($country == 'PL')  {$country_id = '616'; $currency = 'PLN';}
        $endpoint = 'generate';
        if($country == 'RO')  {$endpoint = 'generate_ro';}
        $awb_data = [
        'site_url'      => get_site_url(),
        'username_dpd'  => $username,
        'password_dpd'  => $pass, 
        'service_id'    => $service_id,
        'currency'		=> $currency, 
        'cod_amount'	=> $ramburs,
        'payer'			=> $platitor,
        'parcels_no'	=> $nr_colete,
        'weight'		=> $weight,
        'content'		=> $contents, 
        'private'		=> $private,
        'phone_no'      => $order->get_billing_phone(),
        'client_name'	=> $nume,
        'contact_name'	=> $contactPerson,
        'email'			=> $order->get_billing_email(),
        'site_id'       => get_site_id2($city, $county),
        //'site_name'		=> $city,
        'country_id'	=> $country_id,
        'state_id'		=> $county,
        //'postcode'		=> $_POST['cod_postal'],
        'addressline'	=> $adresa,
        'shipment_note'	=> isset($observatii) ? esc_attr($observatii) : null,
        'ref1'			=> get_bloginfo('name'),
        'ref2'			=> $order->get_id(),
        'saturday'		=> $saturday,
        'obpd_option'   => $open_package,
        'fragile'		=> 'false'
        ];
        $data = json_encode($awb_data);
        $response = (new WOO_DPD_API)->call_API($data,$endpoint);
        //echo '<pre>';
        //print_r($response);
        //echo '</pre>';
        $rasp = json_decode($response);
        if($rasp->id){
            $nr_awb = $rasp->id;
            update_post_meta($order_id, 'dbx_awb_dpd', $nr_awb);
            update_post_meta($order_id, 'dbx_awb_dpd_status', 'AWB-ul a fost inregistrat de catre clientul expeditor.');
            update_post_meta($order_id, 'dbx_awb_dpd_status_id', '0');
            update_post_meta($order_id, 'dbx_dpd_nr_colete', $nr_colete);
            if($update =="Da") $order->update_status( 'completed' );
            add_option( 'dpd_dbx_error', 'AWB-uri DPD generate cu succes.');
        }
        else{
            add_option( 'dpd_dbx_error', 'Eroare la generarea AWB-urilor!');
        }
      }
      catch (Exception $e) {
                $e->getMessage();
      }
    }
}
add_filter('query_vars', function ($vars) {
    $vars[] = "dpd_generate_awb";
    return $vars;
});
add_action('admin_notices','dpd_generate_awb');
add_action( 'woocommerce_order_status_changed', 'dpd_awb_autogenerate', 99, 3);
function dpd_awb_autogenerate($order_id, $old_status, $new_status){
    $settings = (array) get_option( 'dbx-dpd-plugin-settings' );
    $auto = isset($settings['dbx_dpd_autogenerate']) ? esc_attr($settings['dbx_dpd_autogenerate']) : '';
    if($auto != "Da") return;
    if($new_status !== 'processing') return; 
    set_query_var('dpd_generate_awb', $order_id);
    dpd_generate_awb();
}
add_action( 'admin_footer', 'dpd_bulk_actions');
function dpd_bulk_actions() {
	global $post_type;

	if ( 'shop_order' == $post_type ) {	
        wp_enqueue_script( 'dpd_bulk_admin_js', plugin_dir_url(__FILE__).'assets/js/dpd_bulkGenerate.js', array('jquery'), '1.0.0'); 
        wp_enqueue_script( 'dpd_bulk_download_admin_js', plugin_dir_url(__FILE__).'assets/js/dpd_bulkDownload.js', array('jquery'), '1.0.0'); 
	}
}
add_action( 'woocommerce_email_before_order_table', 'dpd_send_awb_details_email', 20, 4 );
function dpd_send_awb_details_email($order, $sent_to_admin, $plain_text, $email){
    if ( $email->id == 'customer_completed_order' ) {
		$awb_id = $order->get_meta('dbx_awb_dpd');
		$tracking = 'https://tracking.dpd.ro/?shipmentNumber='.$awb_id;
		$settings = (array) get_option('dbx-dpd-plugin-settings');
		$update = isset($settings['dbx_dpd_update_mail']) ? esc_attr($settings['dbx_dpd_update_mail']) : '';
		$email_continut = isset($settings['dbx_dpd_text_mail']) ? esc_attr($settings['dbx_dpd_text_mail']) : '';
		$buton = '<a href="'.$tracking.'">URMARESTE COMANDA</a>';	
		$continut = str_replace(array('[nr-awb]', '[buton-urmarire]'), array( $awb_id, $buton), $email_continut);
		if ($awb_id && $email_continut && $update == 'Da'){
			echo $continut;
		}
    }
}
include_once(plugin_dir_path(__FILE__) .'/cron_status.php');