<?php
// Exit if accessed directly
if (!defined('ABSPATH')) exit;

if (!function_exists('is_woocommerce_active')) {
    function is_woocommerce_active(){
        $is_active = in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')));
        if (!$is_active && is_multisite()) {
            $is_active = array_key_exists(
                'woocommerce/woocommerce.php',
                apply_filters('active_plugins', get_site_option('active_sitewide_plugins'))
            );
        }
        return $is_active;
    }
}
if (!function_exists('dbx_get_counties')) {
    function dbx_get_counties( string $county_code = null){
        $counties = [
            "AB" => "Alba", "AR" => "Arad", "AG" => "Arges", "BC" => "Bacau", "BH" => "Bihor", "BN" => "Bistrita-Nasaud", "BT" => "Botosani", "BR" => "Braila", "BV" => "Brasov", "B" => "Bucuresti", "BZ" => "Buzau", "CL" => "Calarasi", "CS" => "Caras-severin", "CJ" => "Cluj", "CT" => "Constanta", "CV" => "Covasna", "DB" => "Dambovita", "DJ" => "Dolj", "GL" => "Galati", "GJ" => "Gorj", "GR" => "Giurgiu", "HR" => "Harghita", "HD" => "Hunedoara", "IL" => "Ialomita", "IS" => "Iasi", "IF" => "Ilfov", "MM" => "Maramures", "MH" => "Mehedinti", "MS" => "Mures", "NT" => "Neamt", "OT" => "Olt", "PH" => "Prahova", "SJ" => "Salaj", "SM" => "Satu Mare", "SB" => "Sibiu", "SV" => "Suceava", "TR" => "Teleorman", "TM" => "Timis", "TL" => "Tulcea", "VS" => "Vaslui", "VL" => "Valcea", "VN" => "Vrancea"
        ];
        return ($county_code && array_key_exists($county_code, $counties))
            ? $counties[$county_code]
            : $counties;
    }
}
if (!function_exists('dbx_get_county_code')) {
function dbx_get_county_code( string $code = null){
    $counties = [
            "AB" => "Alba", "AR" => "Arad", "AG" => "Arges", "BC" => "Bacau", "BH" => "Bihor", "BN" => "Bistrita-Nasaud", "BT" => "Botosani", "BR" => "Braila", "BV" => "Brasov", "B" => "Bucuresti", "BZ" => "Buzau", "CL" => "Calarasi", "CS" => "Caras-severin", "CJ" => "Cluj", "CT" => "Constanta", "CV" => "Covasna", "DB" => "Dambovita", "DJ" => "Dolj", "GL" => "Galati", "GJ" => "Gorj", "GR" => "Giurgiu", "HR" => "Harghita", "HD" => "Hunedoara", "IL" => "Ialomita", "IS" => "Iasi", "IF" => "Ilfov", "MM" => "Maramures", "MH" => "Mehedinti", "MS" => "Mures", "NT" => "Neamt", "OT" => "Olt", "PH" => "Prahova", "SJ" => "Salaj", "SM" => "Satu Mare", "SB" => "Sibiu", "SV" => "Suceava", "TR" => "Teleorman", "TM" => "Timis", "TL" => "Tulcea", "VS" => "Vaslui", "VL" => "Valcea", "VN" => "Vrancea"
        ];
    foreach($counties as $key=>$val) {
        if($val == $code){
            return $key;
        }
    }
}
}
if(!function_exists('get_site_id')){
function get_site_id($name = NULL, $region = NULL){
    global $wpdb;
    $querry = $wpdb->get_row( $wpdb->prepare( "SELECT id FROM dpd_localities WHERE name=%s AND region_code = %s", $name, $region ) );
    $id = $querry->id;
    return $id;
}
}
if(!function_exists('get_site_id2')){
function get_site_id2($name = NULL, $region = NULL){
    global $wpdb;
    $querry = $wpdb->get_row( $wpdb->prepare( "SELECT id FROM dpd_localities WHERE name=%s AND region = %s", $name, $region ) );
    $id = $querry->id;
    return $id;
}
}
add_filter('woocommerce_shop_order_search_fields', 'search_by_dpd_awb');
function search_by_dpd_awb(array $search_fields){
    if (empty($search_fields)) $search_fields = array();
    return array_merge(
        array("dbx_dpd_awb"),
        $search_fields
    );
}